blob: a7124f895b2454179827ccdc7850bdb48aae1085 [file] [log] [blame]
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +02001#!/bin/sh
Greg Kroah-Hartmanb2441312017-11-01 15:07:57 +01002# SPDX-License-Identifier: GPL-2.0
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +02003#
4# link vmlinux
5#
Masahiro Yamadad151e972019-01-17 09:10:04 +09006# vmlinux is linked from the objects selected by $(KBUILD_VMLINUX_OBJS) and
7# $(KBUILD_VMLINUX_LIBS). Most are built-in.a files from top-level directories
8# in the kernel tree, others are specified in arch/$(ARCH)/Makefile.
9# $(KBUILD_VMLINUX_LIBS) are archives which are linked conditionally
10# (not within --whole-archive), and do not require symbol indexes added.
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +020011#
12# vmlinux
13# ^
14# |
Masahiro Yamadad151e972019-01-17 09:10:04 +090015# +--< $(KBUILD_VMLINUX_OBJS)
16# | +--< init/built-in.a drivers/built-in.a mm/built-in.a + more
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +020017# |
Nicholas Piggin3a166fc2017-06-20 01:52:05 +100018# +--< $(KBUILD_VMLINUX_LIBS)
19# | +--< lib/lib.a + more
20# |
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +020021# +-< ${kallsymso} (see description in KALLSYMS section)
22#
23# vmlinux version (uname -v) cannot be updated during normal
24# descending-into-subdirs phase since we do not yet know if we need to
25# update vmlinux.
26# Therefore this step is delayed until just before final link of vmlinux.
27#
28# System.map is generated to document addresses of all kernel symbols
29
30# Error out on error
31set -e
32
33# Nice output in kbuild format
34# Will be supressed by "make -s"
35info()
36{
37 if [ "${quiet}" != "silent_" ]; then
Andrii Nakryikoe83b9f52019-04-02 09:49:50 -070038 printf " %-7s %s\n" "${1}" "${2}"
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +020039 fi
40}
41
42# Link of vmlinux.o used for section mismatch analysis
43# ${1} output file
44modpost_link()
45{
Stephen Rothwella5967db2016-08-24 22:29:19 +100046 local objects
47
Nicholas Piggin6358d6e2018-02-11 00:25:03 +100048 objects="--whole-archive \
Masahiro Yamadad151e972019-01-17 09:10:04 +090049 ${KBUILD_VMLINUX_OBJS} \
Nicholas Piggin6358d6e2018-02-11 00:25:03 +100050 --no-whole-archive \
51 --start-group \
52 ${KBUILD_VMLINUX_LIBS} \
53 --end-group"
54
Masahiro Yamadad503ac52018-08-24 08:20:39 +090055 ${LD} ${KBUILD_LDFLAGS} -r -o ${1} ${objects}
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +020056}
57
58# Link of vmlinux
59# ${1} - optional extra .o files
60# ${2} - output file
61vmlinux_link()
62{
63 local lds="${objtree}/${KBUILD_LDS}"
Stephen Rothwella5967db2016-08-24 22:29:19 +100064 local objects
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +020065
66 if [ "${SRCARCH}" != "um" ]; then
Nicholas Piggin6358d6e2018-02-11 00:25:03 +100067 objects="--whole-archive \
Masahiro Yamadad151e972019-01-17 09:10:04 +090068 ${KBUILD_VMLINUX_OBJS} \
Nicholas Piggin6358d6e2018-02-11 00:25:03 +100069 --no-whole-archive \
70 --start-group \
71 ${KBUILD_VMLINUX_LIBS} \
72 --end-group \
73 ${1}"
Stephen Rothwella5967db2016-08-24 22:29:19 +100074
Masahiro Yamadad503ac52018-08-24 08:20:39 +090075 ${LD} ${KBUILD_LDFLAGS} ${LDFLAGS_vmlinux} -o ${2} \
Stephen Rothwella5967db2016-08-24 22:29:19 +100076 -T ${lds} ${objects}
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +020077 else
Nicholas Piggin6358d6e2018-02-11 00:25:03 +100078 objects="-Wl,--whole-archive \
Masahiro Yamadad151e972019-01-17 09:10:04 +090079 ${KBUILD_VMLINUX_OBJS} \
Nicholas Piggin6358d6e2018-02-11 00:25:03 +100080 -Wl,--no-whole-archive \
81 -Wl,--start-group \
82 ${KBUILD_VMLINUX_LIBS} \
83 -Wl,--end-group \
84 ${1}"
Stephen Rothwella5967db2016-08-24 22:29:19 +100085
Nicholas Piggin6358d6e2018-02-11 00:25:03 +100086 ${CC} ${CFLAGS_vmlinux} -o ${2} \
87 -Wl,-T,${lds} \
88 ${objects} \
Stephen Rothwella5967db2016-08-24 22:29:19 +100089 -lutil -lrt -lpthread
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +020090 rm -f linux
91 fi
92}
93
Andrii Nakryikoe83b9f52019-04-02 09:49:50 -070094# generate .BTF typeinfo from DWARF debuginfo
95gen_btf()
96{
97 local pahole_ver;
98
Andrii Nakryiko581b31c2019-05-05 17:10:33 -070099 if ! [ -x "$(command -v ${PAHOLE})" ]; then
100 info "BTF" "${1}: pahole (${PAHOLE}) is not available"
101 return 0
102 fi
103
Andrii Nakryikoe83b9f52019-04-02 09:49:50 -0700104 pahole_ver=$(${PAHOLE} --version | sed -E 's/v([0-9]+)\.([0-9]+)/\1\2/')
105 if [ "${pahole_ver}" -lt "113" ]; then
106 info "BTF" "${1}: pahole version $(${PAHOLE} --version) is too old, need at least v1.13"
Andrii Nakryiko68e5ab12019-04-15 14:58:39 -0700107 return 0
Andrii Nakryikoe83b9f52019-04-02 09:49:50 -0700108 fi
109
110 info "BTF" ${1}
111 LLVM_OBJCOPY=${OBJCOPY} ${PAHOLE} -J ${1}
112}
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200113
114# Create ${2} .o file with all symbols from the ${1} object file
115kallsyms()
116{
117 info KSYM ${2}
118 local kallsymopt;
119
120 if [ -n "${CONFIG_KALLSYMS_ALL}" ]; then
James Hogan6895f972012-09-06 22:11:25 +0100121 kallsymopt="${kallsymopt} --all-symbols"
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200122 fi
123
Ard Biesheuvel4d5d5662016-03-15 14:58:12 -0700124 if [ -n "${CONFIG_KALLSYMS_ABSOLUTE_PERCPU}" ]; then
Rusty Russellc6bda7c2014-03-17 14:05:46 +1030125 kallsymopt="${kallsymopt} --absolute-percpu"
126 fi
127
Ard Biesheuvel2213e9a2016-03-15 14:58:19 -0700128 if [ -n "${CONFIG_KALLSYMS_BASE_RELATIVE}" ]; then
129 kallsymopt="${kallsymopt} --base-relative"
130 fi
131
Sam Ravnborg00e6c28c2012-05-08 19:53:46 +0200132 local aflags="${KBUILD_AFLAGS} ${KBUILD_AFLAGS_KERNEL} \
133 ${NOSTDINC_FLAGS} ${LINUXINCLUDE} ${KBUILD_CPPFLAGS}"
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200134
Ard Biesheuvela0439342016-02-05 11:25:05 +0100135 local afile="`basename ${2} .o`.S"
136
137 ${NM} -n ${1} | scripts/kallsyms ${kallsymopt} > ${afile}
138 ${CC} ${aflags} -c -o ${2} ${afile}
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200139}
140
141# Create map file with all symbols from ${1}
142# See mksymap for additional details
143mksysmap()
144{
145 ${CONFIG_SHELL} "${srctree}/scripts/mksysmap" ${1} ${2}
146}
147
Linus Torvalds1347a2ce2012-05-28 10:32:28 -0700148sortextable()
149{
150 ${objtree}/scripts/sortextable ${1}
151}
152
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200153# Delete output files in case of error
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200154cleanup()
155{
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200156 rm -f .tmp_System.map
157 rm -f .tmp_kallsyms*
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200158 rm -f .tmp_vmlinux*
159 rm -f System.map
160 rm -f vmlinux
161 rm -f vmlinux.o
162}
163
Sylvain BERTRANDab160db2015-05-07 00:36:04 +0000164on_exit()
165{
166 if [ $? -ne 0 ]; then
167 cleanup
168 fi
169}
170trap on_exit EXIT
171
172on_signals()
173{
174 exit 1
175}
176trap on_signals HUP INT QUIT TERM
177
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200178#
179#
180# Use "make V=1" to debug this script
181case "${KBUILD_VERBOSE}" in
182*1*)
183 set -x
184 ;;
185esac
186
187if [ "$1" = "clean" ]; then
188 cleanup
189 exit 0
190fi
191
192# We need access to CONFIG_ symbols
Masahiro Yamada94cf8ac2019-03-08 14:49:10 +0900193. include/config/auto.conf
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200194
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200195# Update version
196info GEN .version
Masahiro Yamada278ae602017-09-22 14:31:13 +0900197if [ -r .version ]; then
198 VERSION=$(expr 0$(cat .version) + 1)
199 echo $VERSION > .version
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200200else
Masahiro Yamada278ae602017-09-22 14:31:13 +0900201 rm -f .version
202 echo 1 > .version
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200203fi;
204
205# final build of init/
Cao jina7b151f2018-02-21 12:25:07 +0800206${MAKE} -f "${srctree}/scripts/Makefile.build" obj=init
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200207
Nicholas Pigginabac4c82016-11-24 03:41:43 +1100208#link vmlinux.o
209info LD vmlinux.o
210modpost_link vmlinux.o
211
212# modpost vmlinux.o to check for section mismatches
213${MAKE} -f "${srctree}/scripts/Makefile.modpost" vmlinux.o
214
Alexey Gladkov898490c2019-04-29 18:11:14 +0200215info MODINFO modules.builtin.modinfo
216${OBJCOPY} -j .modinfo -O binary vmlinux.o modules.builtin.modinfo
217
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200218kallsymso=""
219kallsyms_vmlinux=""
220if [ -n "${CONFIG_KALLSYMS}" ]; then
221
222 # kallsyms support
223 # Generate section listing all symbols and add it into vmlinux
224 # It's a three step process:
225 # 1) Link .tmp_vmlinux1 so it has all symbols and sections,
226 # but __kallsyms is empty.
227 # Running kallsyms on that gives us .tmp_kallsyms1.o with
228 # the right size
229 # 2) Link .tmp_vmlinux2 so it now has a __kallsyms section of
230 # the right size, but due to the added section, some
231 # addresses have shifted.
232 # From here, we generate a correct .tmp_kallsyms2.o
Nicholas Piggin7e2b37c2016-11-24 03:41:37 +1100233 # 3) That link may have expanded the kernel image enough that
234 # more linker branch stubs / trampolines had to be added, which
235 # introduces new names, which further expands kallsyms. Do another
236 # pass if that is the case. In theory it's possible this results
237 # in even more stubs, but unlikely.
238 # KALLSYMS_EXTRA_PASS=1 may also used to debug or work around
239 # other bugs.
240 # 4) The correct ${kallsymso} is linked into the final vmlinux.
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200241 #
242 # a) Verify that the System.map from vmlinux matches the map from
243 # ${kallsymso}.
244
245 kallsymso=.tmp_kallsyms2.o
246 kallsyms_vmlinux=.tmp_vmlinux2
247
248 # step 1
249 vmlinux_link "" .tmp_vmlinux1
250 kallsyms .tmp_vmlinux1 .tmp_kallsyms1.o
251
252 # step 2
253 vmlinux_link .tmp_kallsyms1.o .tmp_vmlinux2
254 kallsyms .tmp_vmlinux2 .tmp_kallsyms2.o
255
Nicholas Piggin7e2b37c2016-11-24 03:41:37 +1100256 # step 3
Michael Forneya670b0b2018-03-18 17:54:02 -0700257 size1=$(${CONFIG_SHELL} "${srctree}/scripts/file-size.sh" .tmp_kallsyms1.o)
258 size2=$(${CONFIG_SHELL} "${srctree}/scripts/file-size.sh" .tmp_kallsyms2.o)
Nicholas Piggin7e2b37c2016-11-24 03:41:37 +1100259
260 if [ $size1 -ne $size2 ] || [ -n "${KALLSYMS_EXTRA_PASS}" ]; then
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200261 kallsymso=.tmp_kallsyms3.o
262 kallsyms_vmlinux=.tmp_vmlinux3
263
264 vmlinux_link .tmp_kallsyms2.o .tmp_vmlinux3
265
266 kallsyms .tmp_vmlinux3 .tmp_kallsyms3.o
267 fi
268fi
269
270info LD vmlinux
271vmlinux_link "${kallsymso}" vmlinux
272
Andrii Nakryikoe83b9f52019-04-02 09:49:50 -0700273if [ -n "${CONFIG_DEBUG_INFO_BTF}" ]; then
274 gen_btf vmlinux
275fi
276
Linus Torvalds1347a2ce2012-05-28 10:32:28 -0700277if [ -n "${CONFIG_BUILDTIME_EXTABLE_SORT}" ]; then
278 info SORTEX vmlinux
279 sortextable vmlinux
280fi
281
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200282info SYSMAP System.map
283mksysmap vmlinux System.map
284
285# step a (see comment above)
286if [ -n "${CONFIG_KALLSYMS}" ]; then
287 mksysmap ${kallsyms_vmlinux} .tmp_System.map
288
289 if ! cmp -s System.map .tmp_System.map; then
Michal Marek5369f552012-07-07 23:04:40 +0200290 echo >&2 Inconsistent kallsyms data
Michal Marek367e43c2012-08-10 11:55:11 +0200291 echo >&2 Try "make KALLSYMS_EXTRA_PASS=1" as a workaround
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200292 exit 1
293 fi
294fi